/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */


#ifndef __MIDLETINSTALLER_H__
#define __MIDLETINSTALLER_H__

#include <swinstapi.h> 
#include <swinstdefs.h>
#include <aknwaitdialog.h> // wait note

#include "base/util/stringUtils.h"
#include "commonDefs.h"
#include "base/globalsdef.h"
#include "base/SymbianLog.h"
#include "base/util/symbianUtils.h"
#include "base/util/StringBuffer.h"
#include "AOSync.h"

USE_NAMESPACE

class CMidletInstaller 
{
    public: 
        static CMidletInstaller* NewL(const StringBuffer& aJadFile);
        ~CMidletInstaller();

        TBool InstallL();
        void UninstallL(); 

    private:
        TBool InstallMidlet();
#ifdef ENABLE_MIDLET_UNINSTALL
        TBool UninstallMidletL();
#endif        
        TBool IsMidletInstalledL();
        TBool IsJadInstalledL();
        
        CMidletInstaller(const StringBuffer& aJadFile);
        void ConstructL();

    private:
        StringBuffer iJadFile;
        HBufC* iJadPath;  // JAD path as symbian descriptor
        CAOSync* iWaiter; // active object to wait for SWInstSilentLauncher
 
        // installer
        SwiUI::RSWInstSilentLauncher iLauncher;

        // install/unistall Options
        SwiUI::TInstallOptions iInstallOpts;
        SwiUI::TInstallOptionsPckg iInstallOptsPckg;
#ifdef ENABLE_MIDLET_UNINSTALL
        SwiUI::TUninstallOptions iUninstallOpts;
        SwiUI::TUninstallOptionsPckg iUninstallOptsPckg;
#endif

};
#endif // __MIDLETINSTALLER_H__
