/*
 * funambol is a mobile platform developed by funambol, inc.
 * copyright (c) 2009 funambol, inc.
 *
 * this program is free software; you can redistribute it and/or modify it under
 * the terms of the gnu affero general public license version 3 as published by
 * the free software foundation with the addition of the following permission
 * added to section 15 as permitted in section 7(a): for any part of the covered
 * work in which the copyright is owned by funambol, funambol disclaims the
 * warranty of non infringement  of third party rights.
 *
 * this program is distributed in the hope that it will be useful, but without
 * any warranty; without even the implied warranty of merchantability or fitness
 * for a particular purpose.  see the gnu general public license for more
 * details.
 *
 * you should have received a copy of the gnu affero general public license
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the free software foundation, inc., 51 franklin street, fifth floor, boston,
 * ma 02110-1301 usa.
 *
 * you can contact funambol, inc. headquarters at 643 bair island road, suite
 * 305, redwood city, ca 94063, usa, or at email address info@funambol.com.
 *
 * the interactive user interfaces in modified source and object code versions
 * of this program must display appropriate legal notices, as required under
 * section 5 of the gnu affero general public license version 3.
 *
 * in accordance with section 7(b) of the gnu affero general public license
 * version 3, these appropriate legal notices must retain the display of the
 * "powered by funambol" logo. if the display of the logo is not reasonably
 * feasible for technical reasons, the appropriate legal notices must display
 * the words "powered by funambol".
 */


// helper class for inserting bitmap in about view
#include "AboutPicture.h"
#include <fbs.h>

CAboutPicture::CAboutPicture( TSize aSize, CFbsBitmap& aBitmap )
    : iSizeInTwips(aSize), iBitmap(&aBitmap) {}

TBool CAboutPicture::LineBreakPossible( TUint /*aClass*/,
                                           TBool /*aBeforePicture*/,
                                           TBool /*aHaveSpaces*/ ) const
{
    return EFalse;
}

void CAboutPicture::Draw( CGraphicsContext& aGc,
                             const TPoint& aTopLeft,
                             const TRect& aClipRect,
                             MGraphicsDeviceMap* aMap ) const
{
    TRect bitmapRect=aMap->TwipsToPixels(TRect(TPoint(),iSizeInTwips));
    bitmapRect.Move(aTopLeft);
    aGc.Reset();
    aGc.SetClippingRect(aClipRect);
    aGc.DrawBitmap(bitmapRect, iBitmap);
}

void CAboutPicture::ExternalizeL( RWriteStream& /*aStream*/ ) const
{
    // No implementation required
}
        
void CAboutPicture::SetOriginalSizeInTwips( TSize aSize )
{
    iSizeInTwips = aSize;
}

void CAboutPicture::GetOriginalSizeInTwips( TSize& aSize ) const
{
    aSize = iSizeInTwips;
}

