/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2008 - 2009 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

// INCLUDE FILES
#include <coemain.h>
#include "ClientUnitTestAppView.h"

// ============================ MEMBER FUNCTIONS ===============================

// -----------------------------------------------------------------------------
// CClientUnitTestAppView::NewL()
// Two-phased constructor.
// -----------------------------------------------------------------------------
//
CClientUnitTestAppView* CClientUnitTestAppView::NewL(const TRect& aRect)
    {
    CClientUnitTestAppView* self = CClientUnitTestAppView::NewLC(aRect);
    CleanupStack::Pop(self);
    return self;
    }

// -----------------------------------------------------------------------------
// CClientUnitTestAppView::NewLC()
// Two-phased constructor.
// -----------------------------------------------------------------------------
//
CClientUnitTestAppView* CClientUnitTestAppView::NewLC(const TRect& aRect)
    {
    CClientUnitTestAppView* self = new ( ELeave ) CClientUnitTestAppView;
    CleanupStack::PushL(self);
    self->ConstructL(aRect);
    return self;
    }

// -----------------------------------------------------------------------------
// CClientUnitTestAppView::ConstructL()
// Symbian 2nd phase constructor can leave.
// -----------------------------------------------------------------------------
//
void CClientUnitTestAppView::ConstructL(const TRect& aRect)
    {
    // Create a window for this application view
    CreateWindowL();

    // Set the windows size
    SetRect(aRect);

    // Activate the window, which makes it ready to be drawn
    ActivateL();
    }

// -----------------------------------------------------------------------------
// CClientUnitTestAppView::CClientUnitTestAppView()
// C++ default constructor can NOT contain any code, that might leave.
// -----------------------------------------------------------------------------
//
CClientUnitTestAppView::CClientUnitTestAppView()
    {
    // No implementation required
    }

// -----------------------------------------------------------------------------
// CClientUnitTestAppView::~CClientUnitTestAppView()
// Destructor.
// -----------------------------------------------------------------------------
//
CClientUnitTestAppView::~CClientUnitTestAppView()
    {
    // No implementation required
    }

// -----------------------------------------------------------------------------
// CClientUnitTestAppView::Draw()
// Draws the display.
// -----------------------------------------------------------------------------
//
void CClientUnitTestAppView::Draw(const TRect& /*aRect*/) const
    {
    // Get the standard graphics context
    CWindowGc& gc = SystemGc();

    // Gets the control's extent
    TRect drawRect(Rect());

    // Clears the screen
    gc.Clear(drawRect);

    }

// -----------------------------------------------------------------------------
// CClientUnitTestAppView::SizeChanged()
// Called by framework when the view size is changed.
// -----------------------------------------------------------------------------
//
void CClientUnitTestAppView::SizeChanged()
    {
    DrawNow();
    }
// End of File
